// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from LdapManager.idl.

package com.raritan.idl.auth;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface LdapManager_3_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("auth.LdapManager:3.0.1", null);

  public enum ServerType {
    ACTIVE_DIRECTORY,
    OPEN_LDAP;
  }

  public enum SecurityProtocol {
    SEC_PROTO_NONE,
    SEC_PROTO_SSL,
    SEC_PROTO_STARTTLS;
  }

  static public class ServerSettings implements Cloneable {
    public ServerSettings() {
      this.id = new String();
      this.server = new String();
      this.adoptSettingsId = new String();
      this.type = com.raritan.idl.auth.LdapManager_3_0_1.ServerType.values()[0];
      this.secProto = com.raritan.idl.auth.LdapManager_3_0_1.SecurityProtocol.values()[0];
      this.port = new Integer(0);
      this.sslPort = new Integer(0);
      this.forceTrustedCert = new Boolean(false);
      this.allowOffTimeRangeCerts = new Boolean(false);
      this.certificate = new String();
      this.adsDomain = new String();
      this.useAnonymousBind = new Boolean(false);
      this.bindDN = new String();
      this.bindPwd = new String();
      this.searchBaseDN = new String();
      this.loginNameAttr = new String();
      this.userEntryObjClass = new String();
      this.userSearchFilter = new String();
      this.groupInfoInUserEntry = new Boolean(false);
      this.groupMemberAttr = new String();
      this.groupEntryObjClass = new String();
      this.groupSearchFilter = new String();
    }

    public Object clone() {
      ServerSettings copy = new ServerSettings();

      copy.id = this.id;
      copy.server = this.server;
      copy.adoptSettingsId = this.adoptSettingsId;
      copy.type = this.type;
      copy.secProto = this.secProto;
      copy.port = this.port;
      copy.sslPort = this.sslPort;
      copy.forceTrustedCert = this.forceTrustedCert;
      copy.allowOffTimeRangeCerts = this.allowOffTimeRangeCerts;
      copy.certificate = this.certificate;
      copy.adsDomain = this.adsDomain;
      copy.useAnonymousBind = this.useAnonymousBind;
      copy.bindDN = this.bindDN;
      copy.bindPwd = this.bindPwd;
      copy.searchBaseDN = this.searchBaseDN;
      copy.loginNameAttr = this.loginNameAttr;
      copy.userEntryObjClass = this.userEntryObjClass;
      copy.userSearchFilter = this.userSearchFilter;
      copy.groupInfoInUserEntry = this.groupInfoInUserEntry;
      copy.groupMemberAttr = this.groupMemberAttr;
      copy.groupEntryObjClass = this.groupEntryObjClass;
      copy.groupSearchFilter = this.groupSearchFilter;

      return copy;
    }

    public String id;
    public String server;
    public String adoptSettingsId;
    public com.raritan.idl.auth.LdapManager_3_0_1.ServerType type;
    public com.raritan.idl.auth.LdapManager_3_0_1.SecurityProtocol secProto;
    public int port;
    public int sslPort;
    public boolean forceTrustedCert;
    public boolean allowOffTimeRangeCerts;
    public String certificate;
    public String adsDomain;
    public boolean useAnonymousBind;
    public String bindDN;
    public String bindPwd;
    public String searchBaseDN;
    public String loginNameAttr;
    public String userEntryObjClass;
    public String userSearchFilter;
    public boolean groupInfoInUserEntry;
    public String groupMemberAttr;
    public String groupEntryObjClass;
    public String groupSearchFilter;
  }

  public class GetLdapServersResult {
    public java.util.List<com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings> _ret_;
  }

  GetLdapServersResult getLdapServers() throws Exception;

  AsyncRequest getLdapServers(AsyncRpcResponse<GetLdapServersResult> rsp);

  AsyncRequest getLdapServers(AsyncRpcResponse<GetLdapServersResult> rsp, RpcCtrl rpcCtrl);


  public static final int ERR_CYCLIC_DEP = 1;

  public static final int ERR_INVALID_CFG = 2;

  public class SetLdapServersResult {
    public int _ret_;
  }

  SetLdapServersResult setLdapServers(java.util.List<com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings> serverList) throws Exception;

  AsyncRequest setLdapServers(java.util.List<com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings> serverList, AsyncRpcResponse<SetLdapServersResult> rsp);

  AsyncRequest setLdapServers(java.util.List<com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings> serverList, AsyncRpcResponse<SetLdapServersResult> rsp, RpcCtrl rpcCtrl);


  public static final int ERR_SERVER_UNSPECIFIED = 1;

  public static final int ERR_SERVER_UNREACHABLE = 3;

  public static final int ERR_AUTHENTICATION_FAILED = 4;

  public static final int ERR_NO_ROLES = 5;

  public static final int ERR_NO_KNOWN_ROLES = 6;

  public class TestLdapServerResult {
    public int _ret_;
    public String diagMsg;
  }

  TestLdapServerResult testLdapServer(String username, String password, com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings settings) throws Exception;

  AsyncRequest testLdapServer(String username, String password, com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings settings, AsyncRpcResponse<TestLdapServerResult> rsp);

  AsyncRequest testLdapServer(String username, String password, com.raritan.idl.auth.LdapManager_3_0_1.ServerSettings settings, AsyncRpcResponse<TestLdapServerResult> rsp, RpcCtrl rpcCtrl);

}
